
---
title: "connection.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `gloo.solo.io` 
#### Types:


- [ConnectionConfig](#connectionconfig)
- [TcpKeepAlive](#tcpkeepalive)
  



##### Source File: [github.com/solo-io/gloo/projects/gloo/api/v1/connection.proto](https://github.com/solo-io/gloo/blob/master/projects/gloo/api/v1/connection.proto)





---
### ConnectionConfig

 
Fine tune the settings for connections to an upstream

```yaml
"maxRequestsPerConnection": int
"connectTimeout": .google.protobuf.Duration
"tcpKeepalive": .gloo.solo.io.ConnectionConfig.TcpKeepAlive

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `maxRequestsPerConnection` | `int` | Maximum requests for a single upstream connection (unspecified or zero = no limit) |  |
| `connectTimeout` | [.google.protobuf.Duration](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/duration) | The timeout for new network connections to hosts in the cluster |  |
| `tcpKeepalive` | [.gloo.solo.io.ConnectionConfig.TcpKeepAlive](../connection.proto.sk#tcpkeepalive) | Configure OS-level tcp keepalive checks |  |




---
### TcpKeepAlive

 
If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
see more info here: https://www.envoyproxy.io/docs/envoy/latest/api-v2/api/v2/core/address.proto#envoy-api-msg-core-tcpkeepalive

```yaml
"keepaliveProbes": int
"keepaliveTime": .google.protobuf.Duration
"keepaliveInterval": .google.protobuf.Duration

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `keepaliveProbes` | `int` | Maximum number of keepalive probes to send without response before deciding the connection is dead. |  |
| `keepaliveTime` | [.google.protobuf.Duration](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/duration) | The number of seconds a connection needs to be idle before keep-alive probes start being sent. This is rounded up to the second. |  |
| `keepaliveInterval` | [.google.protobuf.Duration](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/duration) | The number of seconds between keep-alive probes. This is rounded up to the second. |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
