
---
title: "load_balancer.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `gloo.solo.io` 
#### Types:


- [LoadBalancerConfig](#loadbalancerconfig)
- [RoundRobin](#roundrobin)
- [LeastRequest](#leastrequest)
- [Random](#random)
  



##### Source File: [github.com/solo-io/gloo/projects/gloo/api/v1/load_balancer.proto](https://github.com/solo-io/gloo/blob/master/projects/gloo/api/v1/load_balancer.proto)





---
### LoadBalancerConfig

 
LoadBalancerConfig is the settings for the load balancer used to send request to the Upstream 
endpoints.

```yaml
"healthyPanicThreshold": .google.protobuf.DoubleValue
"updateMergeWindow": .google.protobuf.Duration
"roundRobin": .gloo.solo.io.LoadBalancerConfig.RoundRobin
"leastRequest": .gloo.solo.io.LoadBalancerConfig.LeastRequest
"random": .gloo.solo.io.LoadBalancerConfig.Random

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `healthyPanicThreshold` | [.google.protobuf.DoubleValue](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/double-value) | Configures envoy's panic threshold Percent between 0-100. Once the number of non health hosts reaches this percentage, envoy disregards health information. see more info [here](https://www.envoyproxy.io/docs/envoy/latest/intro/arch_overview/load_balancing/panic_threshold#arch-overview-load-balancing-panic-threshold). |  |
| `updateMergeWindow` | [.google.protobuf.Duration](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/duration) | This allows batch updates of endspoints helth/weight/metadata that happen during a time window. this help lower cpu usage when endpoint change rate is high. defaults to 1 second. Set to 0 to disable and have changes applied immediately. |  |
| `roundRobin` | [.gloo.solo.io.LoadBalancerConfig.RoundRobin](../load_balancer.proto.sk#roundrobin) | Use round robin for load balancing. |  |
| `leastRequest` | [.gloo.solo.io.LoadBalancerConfig.LeastRequest](../load_balancer.proto.sk#leastrequest) | Use least request for load balancing. |  |
| `random` | [.gloo.solo.io.LoadBalancerConfig.Random](../load_balancer.proto.sk#random) | Use random for load balancing. |  |




---
### RoundRobin



```yaml

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 




---
### LeastRequest



```yaml
"choiceCount": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `choiceCount` | `int` | How many choices to take into account. defaults to 2. |  |




---
### Random



```yaml

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
