
---
title: "aws.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `aws.plugins.gloo.solo.io` 
#### Types:


- [UpstreamSpec](#upstreamspec)
- [LambdaFunctionSpec](#lambdafunctionspec)
- [DestinationSpec](#destinationspec)
- [InvocationStyle](#invocationstyle)
  



##### Source File: [github.com/solo-io/gloo/projects/gloo/api/v1/plugins/aws/aws.proto](https://github.com/solo-io/gloo/blob/master/projects/gloo/api/v1/plugins/aws/aws.proto)





---
### UpstreamSpec

 
Upstream Spec for AWS Lambda Upstreams
AWS Upstreams represent a collection of Lambda Functions for a particular AWS Account (IAM Role or User account)
in a particular region

```yaml
"region": string
"secretRef": .core.solo.io.ResourceRef
"lambdaFunctions": []aws.plugins.gloo.solo.io.LambdaFunctionSpec

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `region` | `string` | The AWS Region where the desired Lambda Functions exxist |  |
| `secretRef` | [.core.solo.io.ResourceRef](../../../../../../../../solo-kit/api/v1/ref.proto.sk#resourceref) | A [Gloo Secret Ref](https://gloo.solo.io/introduction/concepts/#Secrets) to an AWS Secret AWS Secrets can be created with `glooctl secret create aws ...` If the secret is created manually, it must conform to the following structure: ``` access_key: <aws access key> secret_key: <aws secret key> ``` |  |
| `lambdaFunctions` | [[]aws.plugins.gloo.solo.io.LambdaFunctionSpec](../aws.proto.sk#lambdafunctionspec) | The list of Lambda Functions contained within this region. This list will be automatically populated by Gloo if discovery is enabled for AWS Lambda Functions |  |




---
### LambdaFunctionSpec

 
Each Lambda Function Spec contains data necessary for Gloo to invoke Lambda functions:
- name of the function
- qualifier for the function

```yaml
"logicalName": string
"lambdaFunctionName": string
"qualifier": string

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `logicalName` | `string` | the logical name gloo should associate with this function. if left empty, it will default to lambda_function_name+qualifier |  |
| `lambdaFunctionName` | `string` | The Name of the Lambda Function as it appears in the AWS Lambda Portal |  |
| `qualifier` | `string` | The Qualifier for the Lambda Function. Qualifiers act as a kind of version for Lambda Functions. See https://docs.aws.amazon.com/lambda/latest/dg/API_Invoke.html for more info. |  |




---
### DestinationSpec

 
Each Lambda Function Spec contains data necessary for Gloo to invoke Lambda functions

```yaml
"logicalName": string
"invocationStyle": .aws.plugins.gloo.solo.io.DestinationSpec.InvocationStyle
"responseTransformation": bool

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `logicalName` | `string` | The Logical Name of the LambdaFunctionSpec to be invoked. |  |
| `invocationStyle` | [.aws.plugins.gloo.solo.io.DestinationSpec.InvocationStyle](../aws.proto.sk#invocationstyle) | Can be either Sync or Async. |  |
| `responseTransformation` | `bool` | de-jsonify response bodies returned from aws lambda |  |




---
### InvocationStyle



| Name | Description |
| ----- | ----------- | 
| `SYNC` |  |
| `ASYNC` |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
