
---
title: "grpc.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `grpc.plugins.gloo.solo.io` 
#### Types:


- [ServiceSpec](#servicespec)
- [GrpcService](#grpcservice)
- [DestinationSpec](#destinationspec)
  



##### Source File: [github.com/solo-io/gloo/projects/gloo/api/v1/plugins/grpc/grpc.proto](https://github.com/solo-io/gloo/blob/master/projects/gloo/api/v1/plugins/grpc/grpc.proto)





---
### ServiceSpec

 
Service spec describing GRPC upstreams. This will usually be filled
automatically via function discovery (if the upstream supports reflection).
If your upstream service is a GRPC service, use this service spec (an empty
spec is fine), to make sure that traffic to it is routed with http2.

```yaml
"descriptors": bytes
"grpcServices": []grpc.plugins.gloo.solo.io.ServiceSpec.GrpcService

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `descriptors` | `bytes` | Descriptors that contain information of the services listed below. this is a serialized google.protobuf.FileDescriptorSet |  |
| `grpcServices` | [[]grpc.plugins.gloo.solo.io.ServiceSpec.GrpcService](../grpc.proto.sk#grpcservice) | List of services used by this upstream. For a grpc upstream where you don't need to use Gloo's function routing, this can be an empty list. These services must be present in the descriptors. |  |




---
### GrpcService

 
Describes a grpc service

```yaml
"packageName": string
"serviceName": string
"functionNames": []string

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `packageName` | `string` | The package of this service. |  |
| `serviceName` | `string` | The service name of this service. |  |
| `functionNames` | `[]string` | The functions available in this service. |  |




---
### DestinationSpec

 
This is only for upstream with Grpc service spec.

```yaml
"package": string
"service": string
"function": string
"parameters": .transformation.plugins.gloo.solo.io.Parameters

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `package` | `string` | The proto package of the function. |  |
| `service` | `string` | The name of the service of the function. |  |
| `function` | `string` | The name of the function. |  |
| `parameters` | [.transformation.plugins.gloo.solo.io.Parameters](../../transformation/parameters.proto.sk#parameters) | Parameters describe how to extract the function parameters from the request. |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
