
---
title: "static.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `static.plugins.gloo.solo.io` 
#### Types:


- [UpstreamSpec](#upstreamspec)
- [Host](#host)
  



##### Source File: [github.com/solo-io/gloo/projects/gloo/api/v1/plugins/static/static.proto](https://github.com/solo-io/gloo/blob/master/projects/gloo/api/v1/plugins/static/static.proto)





---
### UpstreamSpec

 
Static upstreams are used to route request to services listening at fixed IP/Addresses.
Static upstreams can be used to proxy any kind of service, and therefore contain a ServiceSpec
for additional service-specific configuration.
Unlike upstreams created by service discovery, Static Upstreams must be created manually by users

```yaml
"hosts": []static.plugins.gloo.solo.io.Host
"useTls": bool
"serviceSpec": .plugins.gloo.solo.io.ServiceSpec
"useHttp2": bool

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `hosts` | [[]static.plugins.gloo.solo.io.Host](../static.proto.sk#host) | A list of addresses and ports at least one must be specified |  |
| `useTls` | `bool` | Attempt to use outbound TLS Gloo will automatically set this to true for port 443 |  |
| `serviceSpec` | [.plugins.gloo.solo.io.ServiceSpec](../../service_spec.proto.sk#servicespec) | An optional Service Spec describing the service listening at this address |  |
| `useHttp2` | `bool` | Use http2 when communicating with this upstream |  |




---
### Host

 
Represents a single instance of an upstream

```yaml
"addr": string
"port": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `addr` | `string` | Address (hostname or IP) |  |
| `port` | `int` | Port the instance is listening on |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
