
---
title: "metadata.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `core.solo.io` 
#### Types:


- [Metadata](#metadata)
  



##### Source File: [github.com/solo-io/solo-kit/api/v1/metadata.proto](https://github.com/solo-io/solo-kit/blob/master/api/v1/metadata.proto)





---
### Metadata

 
*
Metadata contains general properties of resources for purposes of versioning, annotating, and namespacing.

```yaml
"name": string
"namespace": string
"cluster": string
"resourceVersion": string
"labels": map<string, string>
"annotations": map<string, string>

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `name` | `string` | Name of the resource. Names must be unique and follow the following syntax rules: One or more lowercase rfc1035/rfc1123 labels separated by '.' with a maximum length of 253 characters. |  |
| `namespace` | `string` | Namespace is used for the namespacing of resources. |  |
| `cluster` | `string` | Cluster indicates the cluster this resource belongs to Cluster is only applicable in certain contexts, e.g. Kubernetes An empty string here refers to the local cluster |  |
| `resourceVersion` | `string` | An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. |  |
| `labels` | `map<string, string>` | Map of string keys and values that can be used to organize and categorize (scope and select) objects. Some resources contain `selectors` which can be linked with other resources by their labels |  |
| `annotations` | `map<string, string>` | Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
