
---
title: "struct.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `google.protobuf`  
Protocol Buffers - Google's data interchange format
Copyright 2008 Google Inc.  All rights reserved.
https://developers.google.com/protocol-buffers/

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

    * Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the
distribution.
    * Neither the name of Google Inc. nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


 
#### Types:


- [Struct](#struct)
- [Value](#value)
- [ListValue](#listvalue)
  

 

##### Enums:


	- [NullValue](#nullvalue)



##### Source File: `google/protobuf/struct.proto`





---
### Struct

 
`Struct` represents a structured data value, consisting of fields
which map to dynamically typed values. In some languages, `Struct`
might be supported by a native representation. For example, in
scripting languages like JS a struct is represented as an
object. The details of that representation are described together
with the proto support for the language.

The JSON representation for `Struct` is JSON object.

```yaml
"fields": map<string, .google.protobuf.Value>

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `fields` | `map<string, .google.protobuf.Value>` | Unordered map of dynamically typed values. |  |




---
### Value

 
`Value` represents a dynamically typed value which can be either
null, a number, a string, a boolean, a recursive struct value, or a
list of values. A producer of value is expected to set one of that
variants, absence of any variant indicates an error.

The JSON representation for `Value` is JSON value.

```yaml
"nullValue": .google.protobuf.NullValue
"numberValue": float
"stringValue": string
"boolValue": bool
"structValue": .google.protobuf.Struct
"listValue": .google.protobuf.ListValue

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `nullValue` | [.google.protobuf.NullValue](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/null-value) | Represents a null value. |  |
| `numberValue` | `float` | Represents a double value. |  |
| `stringValue` | `string` | Represents a string value. |  |
| `boolValue` | `bool` | Represents a boolean value. |  |
| `structValue` | [.google.protobuf.Struct](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/struct) | Represents a structured value. |  |
| `listValue` | [.google.protobuf.ListValue](https://developers.google.com/protocol-buffers/docs/reference/csharp/class/google/protobuf/well-known-types/list-value) | Represents a repeated `Value`. |  |




---
### ListValue

 
`ListValue` is a wrapper around a repeated field of values.

The JSON representation for `ListValue` is JSON array.

```yaml
"values": []google.protobuf.Value

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `values` | [[]google.protobuf.Value](../struct.proto.sk#value) | Repeated field of dynamically typed values. |  |



  
### NullValue

Description: `NullValue` is a singleton enumeration to represent the null value for the
`Value` type union.

 The JSON representation for `NullValue` is JSON `null`.

| Name | Description |
| ----- | ----------- | 
| NULL_VALUE | Null value. |


<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
