
---
title: "wrappers.proto"
weight: 5
---

<!-- Code generated by solo-kit. DO NOT EDIT. -->


### Package: `google.protobuf`  
Protocol Buffers - Google's data interchange format
Copyright 2008 Google Inc.  All rights reserved.
https://developers.google.com/protocol-buffers/

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

    * Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the
distribution.
    * Neither the name of Google Inc. nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  
Wrappers for primitive (non-message) types. These types are useful
for embedding primitives in the `google.protobuf.Any` type and for places
where we need to distinguish between the absence of a primitive
typed field and its default value.


 
#### Types:


- [DoubleValue](#doublevalue)
- [FloatValue](#floatvalue)
- [Int64Value](#int64value)
- [UInt64Value](#uint64value)
- [Int32Value](#int32value)
- [UInt32Value](#uint32value)
- [BoolValue](#boolvalue)
- [StringValue](#stringvalue)
- [BytesValue](#bytesvalue)
  



##### Source File: `google/protobuf/wrappers.proto`





---
### DoubleValue

 
Wrapper message for `double`.

The JSON representation for `DoubleValue` is JSON number.

```yaml
"value": float

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `float` | The double value. |  |




---
### FloatValue

 
Wrapper message for `float`.

The JSON representation for `FloatValue` is JSON number.

```yaml
"value": float

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `float` | The float value. |  |




---
### Int64Value

 
Wrapper message for `int64`.

The JSON representation for `Int64Value` is JSON string.

```yaml
"value": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `int` | The int64 value. |  |




---
### UInt64Value

 
Wrapper message for `uint64`.

The JSON representation for `UInt64Value` is JSON string.

```yaml
"value": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `int` | The uint64 value. |  |




---
### Int32Value

 
Wrapper message for `int32`.

The JSON representation for `Int32Value` is JSON number.

```yaml
"value": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `int` | The int32 value. |  |




---
### UInt32Value

 
Wrapper message for `uint32`.

The JSON representation for `UInt32Value` is JSON number.

```yaml
"value": int

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `int` | The uint32 value. |  |




---
### BoolValue

 
Wrapper message for `bool`.

The JSON representation for `BoolValue` is JSON `true` and `false`.

```yaml
"value": bool

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `bool` | The bool value. |  |




---
### StringValue

 
Wrapper message for `string`.

The JSON representation for `StringValue` is JSON string.

```yaml
"value": string

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `string` | The string value. |  |




---
### BytesValue

 
Wrapper message for `bytes`.

The JSON representation for `BytesValue` is JSON string.

```yaml
"value": bytes

```

| Field | Type | Description | Default |
| ----- | ---- | ----------- |----------- | 
| `value` | `bytes` | The bytes value. |  |





<!-- Start of HubSpot Embed Code -->
<script type="text/javascript" id="hs-script-loader" async defer src="//js.hs-scripts.com/5130874.js"></script>
<!-- End of HubSpot Embed Code -->
